# Laravel Zoho CRM (v3)

[![Latest Version on Packagist](https://img.shields.io/packagist/v/crezra/laravel-zoho-crm.svg?style=flat-square)](https://packagist.org/packages/crezra/laravel-zoho-crm)
[![Total Downloads](https://img.shields.io/packagist/dt/crezra/laravel-zoho-crm.svg?style=flat-square)](https://packagist.org/packages/crezra/laravel-zoho-crm)

This package provides a wrapper around the Zoho CRM PHP SDK (version 3)

## Requirements

- a Zoho CRM account
- a Zoho CRM Application credentials
- PHP version `>= 7.4`
- Laravel `^8.0`

## Zoho Application setup

First you need to create a new application in your Zoho console.

Guide : https://www.zoho.com/crm/developer/docs/api/v2/register-client.html

Summary :

1. Create a new application as a `Server-based Application`
2. Set a name for your client, and a homepage URL and a callback URI, we are going to be using this callback URI later
3. Retrieve your Client ID and Client Secret

## Installation

You can install the package via composer:

```bash
composer require crezra/laravel-zoho-crm
```

## Laravel Zoho CRM Setup

### Environment

Add the following to your `.env` file

```env
ZOHO_CLIENT_ID=1000.XXXX.YYY
ZOHO_CLIENT_SECRET=<your client secret>
ZOHO_REDIRECT_URL=http://localhost/zoho/callback
ZOHO_USER_EMAIL=<your zoho account email>
```

**Note :** If you need to use a different callback uri that the one defined by the package, you have to make sure to
have the same uri in your Zoho console settings page for your application, and setup the route in your application

```php
# routes/web.php

use BBSLab\ZohoCRM\Http\Controllers\OAuthController;

Route::get('foo/bar', [OAuthController::class, 'callback']);
```

### Migrations

Currently, only a database store is supported by the package to persist the oauth tokens generated by the API.

First run the migrations with :

```bash
php artisan migrate
```

### Authentication

You'll then need to log in to your Zoho CRM account, you can run the following command :

```php
php artisan zoho:auth
```

This will provide you with a link you'll need to open in your browser and authenticate your Zoho CRM account.

**Note :** The email used for the authentication process will need to be added in the configuration, you can do so by
adjuting your `.env` file with the corresponding `ZOHO_USER_EMAIL` value.

Upon authenticating your account, you should be getting a response that looks like this :

```json
{
  "status": 200,
  "message": "Your Zoho CRM account was successfully authenticated"
}
```

otherwise, if you get an error, you'll then need to check your application logs :

```json
{
  "status": 500,
  "message": "There was an error authenticating your Zoho CRM account"
}
```

Your application is now setup and ready to use with Zoho CRM

## Configuration

You can extend and customize the package's configuration by publishing the config file :

```bash
php artisan vendor:publish --tag="zohocrm-config"
```

| Key                    | Description                           | Value                                                      |
|------------------------|---------------------------------------|------------------------------------------------------------|
| `oauth.host`           | Hostname for the authentication       | `accounts.zoho.eu` `accounts.zoho.cn` `accounts.zoho.com`  |
| `oauth.scopes`         | Scopes for the token generation       | Defaults to `ZohoCRM.modules.ALL` `ZohoCRM.settings.ALL`   |
| `email`                | Email used for the authentication     | Should be set to your Zoho CRM account email               |
| `persistence`          | Token persistence location            | `StoreType::DATABASE()` : saves the tokens to the database |
| `logger.level`         | Event log level for the Zoho API      | `ALL`, `TRACE`, `DEBUG`, `INFO`, `WARNING`, `ERROR`, `FATAL`             |
| `logger.path`          | File path for logging                 | `storage_path('logs/zoho.log')`                            |
| `data_center.location` | Location for the Zoho CRM environment | `EU`,`US`,`CN`,`INDIA`,`AU`                                          |
| `data_center.environment`    |  Zoho CRM environment type      | `PRODUCTION`,`DEVELOPER`,`SANDBOX`                                                           |
| `stores.database.table_name` |  Defines the table name used to save tokens  | `zoho_oauth_tokens`                                                           |

## Usage

### Available modules

| Module   | Available methods | Class                                    |
|----------|-------------------|------------------------------------------|
| Leads    | `create`          | `BBSLab\ZohoCRM\Modules\Leads::class`    |
| Contacts | `create`          | `BBSLab\ZohoCRM\Modules\Contacts::class` |

**Tip :** You can find all the available modules in `BBSLab\ZohoCRM\Enums\ModuleType.php`

### Example : Creating a new Lead

```php
use BBSLab\ZohoCRM\Modules\Leads;

$values = [
    'Last_Name' => 'John Doe',
];

$response = (new Leads())->create($values);

# response is an instance of ApiResponse
```

### Fields and values

Each module has a mandatory field, and omitting it from the input array will throw a `MissingMandatoryFieldsException`

You can pass your fields as a key value array, where the keys are the `api_Name` of each field in your module in your
Zoho CRM instance.

To make life easier, a handy helper is available to retrive all the available fields in the given module type :

```bash
php artisan zoho:fields Leads
```

This is will print a table containing the fields, and provides a column for `systemMandatory` that requires that field
to be present in the input if it is set to true.

The column `mandatory` is for the fields that are user-defined mandatory fields.

## Testing

```bash
composer test
```

## TODO
- [ ] Adding all operations for existing Modules
- [ ] Adding more modules

## FAQ
- Q : How do I setup the package to use a different authentication domain ?  
A  : Take a look at `zohocrm.oauth.host`
- Q : How do I setup the package to use a different environment configuration ?  
A : Take a look at `zohocrm.data_center`
## Changelog

Please see [CHANGELOG](CHANGELOG.md) for more information what has changed recently.

## Contributing

Please see [CONTRIBUTING](CONTRIBUTING.md) for details.

### Security

If you discover any security related issues, please email charaf@big-boss-studio.com instead of using the issue tracker.

## Credits

- [Charaf Rezrazi](https://github.com/crezra)
- [All Contributors](../../contributors)

## License

The MIT License (MIT). Please see [License File](LICENSE.md) for more information.
